'use strict';

var oauthSignature = require('oauth-signature');

oauthSignature.generate = function (httpMethod, url, parameters, consumerSecret, tokenSecret, options) {
  url = url.replace(/fanfou\.pro/, 'fanfou.com').replace('https', 'http');
  var signatureBaseString = new oauthSignature.SignatureBaseString(httpMethod, url, parameters).generate();
  var encodeSignature = true;
  if (options) {
    encodeSignature = options.encodeSignature;
  }
  return new oauthSignature.HmacSha1Signature(signatureBaseString, consumerSecret, tokenSecret).generate(encodeSignature);
};

module.exports = oauthSignature;